## mlton 20210117+dfsg

=== Makefile ===
## Copyright (C) 2009,2011,2013,2017-2020 Matthew Fluet.
 # Copyright (C) 1999-2007 Henry Cejtin, Matthew Fluet, Suresh
 #    Jagannathan, and Stephen Weeks.
 # Copyright (C) 1997-2000 NEC Research Institute.
 #
 # MLton is released under a HPND-style license.
 # See the file MLton-LICENSE for details.
 ##

ROOT := .
include $(ROOT)/Makefile.config

######################################################################

.PHONY: all
all:
	$(MAKE) dirs
	$(MAKE) runtime
	$(MAKE) compiler CHECK_FIXPOINT=false                     # tools0 + mlton0 -> mlton1
	$(MAKE) script
	$(MAKE) basis
	$(MAKE) libraries
	$(MAKE) tools    CHECK_FIXPOINT=false                     # tools0 + mlton1 -> tools1
ifeq (2, $(firstword $(sort $(BOOTSTRAP_STYLE) 2)))
	$(MAKE) compiler-clean
	$(MAKE) compiler SELF_COMPILE=true  CHECK_FIXPOINT=false  # tools1 + mlton1 -> mlton2
ifeq (3, $(firstword $(sort $(BOOTSTRAP_STYLE) 3)))
	$(MAKE) tools-clean
	$(MAKE) tools    CHECK_FIXPOINT=true                      # tools1 + mlton2 -> tools2; tools2 == tools1
	$(MAKE) compiler-clean
	$(MAKE) compiler SELF_COMPILE=true  CHECK_FIXPOINT=true   # tools2 + mlton2 -> mlton3; mlton3 == mlton2
endif
endif
	@echo 'Build of MLton succeeded.'

.PHONY: clean
clean:
	$(SRC)/bin/clean --exclude package

.PHONY: clean-git
clean-git:
	$(FIND) . -type d -name .git -prune -exec $(RM) '{}' ';'

.PHONY: check
check:
	./bin/regression $(CHECK_ARGS)

$(eval $(MK_SHOW_CONFIG))

######################################################################

.PHONY: basis-no-check
basis-no-check:
	$(RM) "$(LIB)/sml/basis"
	$(MKDIR) "$(LIB)/sml/basis"
	( \
	cd "$(SRC)/basis-library" && \
	$(FIND) . -type f '(' -name '*.mlb' -o -name '*.sml' -o -name '*.sig' -o -name '*.fun' ')' | \
	$(XARGS) $(TAR) cf - | \
	( cd "$(LIB)/sml/basis" && $(TAR) xf - ) \
	)

.PHONY: basis-check
basis-check:
	@echo 'Type checking basis.'
	"$(BIN)/$(MLTON)" -disable-ann deadCode -stop tc '$$(SML_LIB)/basis/libs/all.mlb' >/dev/null

.PHONY: basis
basis:
	$(MAKE) basis-no-check
	$(MAKE) basis-check

.PHONY: compiler
compiler:
	$(MAKE) -C "$(SRC)/mlton"
ifeq (true, $(CHECK_FIXPOINT))
	$(DIFF) -b "$(SRC)/mlton/$(MLTON_OUTPUT)$(EXE)" "$(LIB)/$(MLTON_OUTPUT)$(EXE)"
endif
	$(CP) "$(SRC)/mlton/$(MLTON_OUTPUT)$(EXE)" "$(LIB)/"

.PHONY: compiler-clean
compiler-clean:
	$(MAKE) -C "$(SRC)/mlton" clean

.PHONY: dirs
dirs:
	$(MKDIR) "$(BIN)" "$(LIB)" "$(INC)"
	$(MKDIR) "$(LIB)/targets/$(TARGET)/include"
	$(MKDIR) "$(LIB)/targets/$(TARGET)/sml"

.PHONY: docs
docs:
	$(MAKE) -C "$(SRC)/doc/guide"

define LIBRARIES_NO_CHECK_TEMPLATE
	$(RM) "$(LIB)/sml/$(1)"
	$(MKDIR) "$(LIB)/sml/$(1)"
	( \
	cd "$(SRC)/lib/$(1)$(2)" && \
	$(FIND) . '!' -path '*/.cm/*' $(3) -type f '(' -name '*.mlb' -o -name '*.sml' -o -name '*.sig' -o -name '*.fun' ')' | \
	$(XARGS) $(TAR) cf - | \
	( cd "$(LIB)/sml/$(1)" && $(TAR) xf - ) \
	)

endef

.PHONY: libraries-no-check
libraries-no-check:
	$(MAKE) -C "$(SRC)/lib/ckit-lib"
	$(call LIBRARIES_NO_CHECK_TEMPLATE,ckit-lib,/ckit/src,)
	$(call LIBRARIES_NO_CHECK_TEMPLATE,cml,,'!' -path '*/tests/*')
	$(MAKE) -C "$(SRC)/lib/mllpt-lib"
	$(call LIBRARIES_NO_CHECK_TEMPLATE,mllpt-lib,/ml-lpt/lib,)
	$(MAKE) -C "$(SRC)/lib/mlnlffi-lib"
	$(call LIBRARIES_NO_CHECK_TEMPLATE,mlnlffi-lib,,)
	$(MAKE) -C "$(SRC)/lib/mlrisc-lib"
	$(call LIBRARIES_NO_CHECK_TEMPLATE,mlrisc-lib,/MLRISC,'!' -path '*/demo/*' '!' -path '*/Tools/*' '!' -path './autoload.sml' '!' -path './make*.sml')
	$(call LIBRARIES_NO_CHECK_TEMPLATE,mlyacc-lib,,)
	$(MAKE) -C "$(SRC)/lib/smlnj-lib"
	$(call LIBRARIES_NO_CHECK_TEMPLATE,smlnj-lib,/smlnj-lib,'!' -path '*/examples/*' '!' -path '*/tests/*' '!' -path '*/Tests/*')

define LIBRARIES_CHECK_TEMPLATE
	@echo "Type checking $(1) library."
	"$(BIN)/$(MLTON)" -disable-ann deadCode -stop tc '$$(SML_LIB)/$(1)/$(1).mlb' >/dev/null
endef

.PHONY: libraries-check
libraries-check:
	$(call LIBRARIES_CHECK_TEMPLATE,ckit-lib)
	$(call LIBRARIES_CHECK_TEMPLATE,cml)
	$(call LIBRARIES_CHECK_TEMPLATE,mllpt-lib)
	$(call LIBRARIES_CHECK_TEMPLATE,mlnlffi-lib)
	$(call LIBRARIES_CHECK_TEMPLATE,mlrisc-lib)
	$(call LIBRARIES_CHECK_TEMPLATE,mlyacc-lib)
	$(call LIBRARIES_CHECK_TEMPLATE,smlnj-lib)

.PHONY: libraries
libraries:
	$(MAKE) libraries-no-check
	$(MAKE) libraries-check

.PHONY: runtime
runtime:
	@echo 'Compiling MLton runtime system for $(TARGET).'
	$(MAKE) -C "$(SRC)/runtime"
	$(CP) "$(SRC)/include/"*.h "$(INC)/"
	$(CP) "$(SRC)/runtime/"*.a "$(LIB)/targets/$(TARGET)/"
	$(CP) "$(SRC)/runtime/gen/constants" "$(LIB)/targets/$(TARGET)/"
	$(CP) "$(SRC)/runtime/gen/c-types.sml" "$(LIB)/targets/$(TARGET)/sml/"
	echo "$(TARGET_OS)" > "$(LIB)/targets/$(TARGET)/os"
	echo "$(TARGET_ARCH)" > "$(LIB)/targets/$(TARGET)/arch"
	$(CP) "$(SRC)/runtime/gen/basis-ffi.sml" \
		basis-library/primitive/basis-ffi.sml
	$(CP) "$(SRC)/runtime/"*.h "$(INC)/"
	$(MV) "$(INC)/c-types.h" "$(LIB)/targets/$(TARGET)/include"
	for d in basis basis/Real basis/Word gc platform util; do	\
		$(MKDIR) "$(INC)/$$d";					\
		$(CP) "$(SRC)/runtime/$$d/"*.h "$(INC)/$$d";		\
	done

.PHONY: script
script:
	$(SED) \
		-e "s;^LIB_REL_BIN=.*;LIB_REL_BIN=\"$(LIB_REL_BIN)\";" \
		-e "s;^EXE=.*;EXE=\"$(EXE)\";" \
		-e "s;^CC=.*;CC=\"$(CC)\";" \
		-e "s;^GMP_INC_DIR=.*;GMP_INC_DIR=\"$(WITH_GMP_INC_DIR)\";" \
		-e "s;^GMP_LIB_DIR=.*;GMP_LIB_DIR=\"$(WITH_GMP_LIB_DIR)\";" \
		-e 's/mlton-compile/$(MLTON_OUTPUT)/' \
		< "$(SRC)/bin/mlton-script" > "$(BIN)/$(MLTON)"
	$(CHMOD) a+x "$(BIN)/$(MLTON)"
	$(CP) "$(SRC)/bin/static-library" "$(LIB)"
ifeq (mingw, $(TARGET_OS))
	$(CP) "$(SRC)/bin/static-library.bat" "$(LIB)"
endif

ifeq (true, $(CHECK_FIXPOINT))
define TOOLS_TEMPLATE_CHECK_FIXPOINT
	$(DIFF) -b "$(SRC)/$(1)/$(1)$(EXE)" "$(BIN)/$(1)$(EXE)"
endef
else
define TOOLS_TEMPLATE_CHECK_FIXPOINT
endef
endif

define TOOLS_TEMPLATE
	+$(MAKE) -C "$(SRC)/$(1)"
	$(call TOOLS_TEMPLATE_CHECK_FIXPOINT,$(1))
	$(CP) "$(SRC)/$(1)/$(1)$(EXE)" "$(BIN)/"
endef

.PHONY: tools
tools:
	$(call TOOLS_TEMPLATE,mllex)
	$(call TOOLS_TEMPLATE,mlyacc)
	$(call TOOLS_TEMPLATE,mlprof)
	$(call TOOLS_TEMPLATE,mlnlffigen)

.PHONY: tools-clean
tools-clean:
	$(MAKE) -C "$(SRC)/mllex" clean
	$(MAKE) -C "$(SRC)/mlyacc" clean
	$(MAKE) -C "$(SRC)/mlprof" clean
	$(MAKE) -C "$(SRC)/mlnlffigen" clean

######################################################################

# debugged, profiled, traced targets

.PHONY: debugged
debugged:
	$(MAKE) -C "$(SRC)/mlton" MLTON_NAME="$(MLTON_NAME) (debug)" MLTON_OUTPUT=$(MLTON_OUTPUT).debug \
		MLTON_COMPILE_ARGS="$(MLTON_COMPILE_ARGS) -debug true -const 'Exn.keepHistory true' -profile-val true -const 'MLton.debug true' -disable-pass 'deepFlatten'"
	$(CP) "$(SRC)/mlton/$(MLTON_OUTPUT).debug$(EXE)" "$(LIB)/"
	$(SED) -e 's/$(MLTON_OUTPUT)/$(MLTON_OUTPUT).debug/' \
		< "$(BIN)/$(MLTON)" \
		> "$(BIN)/$(MLTON).debug"
	$(CHMOD) u+x "$(BIN)/$(MLTON).debug"

define PROFILED_TEMPLATE
	+$(MAKE) -C "$(SRC)/mlton" MLTON_NAME="$(MLTON_NAME) (profile-$(1))" MLTON_OUTPUT=$(MLTON_OUTPUT).$(1) \
		MLTON_COMPILE_ARGS="$(MLTON_COMPILE_ARGS) -profile $(1)"
	$(CP) "$(SRC)/mlton/$(MLTON_OUTPUT).$(1)$(EXE)" "$(LIB)/"
	$(SED) -e "s/$(MLTON_OUTPUT)/$(MLTON_OUTPUT).$(1)/" \
		< "$(BIN)/$(MLTON)" \
		>"$(BIN)/$(MLTON).$(1)"
	$(CHMOD) u+x "$(BIN)/$(MLTON).$(1)"
endef

.PHONY: profiled-alloc
profiled-alloc:
	$(call PROFILED_TEMPLATE,alloc)

.PHONY: profiled-count
profiled-count:
	$(call PROFILED_TEMPLATE,count)

.PHONY: profiled-time
profiled-time:
	$(call PROFILED_TEMPLATE,time)

.PHONY: profiled
profiled:
	$(MAKE) profiled-alloc
	$(MAKE) profiled-count
	$(MAKE) profiled-time

.PHONY: traced
traced:
	$(MAKE) -C "$(SRC)/mlton" MLTON_NAME="$(MLTON_NAME) (trace)" MLTON_OUTPUT=$(MLTON_OUTPUT).trace \
		MLTON_COMPILE_ARGS="$(MLTON_COMPILE_ARGS) -const 'Exn.keepHistory true' -profile-val true -const 'MLton.debug true' -disable-pass 'deepFlatten'"
	$(CP) "$(SRC)/mlton/$(MLTON_OUTPUT).trace$(EXE)" "$(LIB)/"
	$(SED) -e 's/$(MLTON_OUTPUT)/$(MLTON_OUTPUT).trace/' \
		< "$(BIN)/$(MLTON)" \
		> "$(BIN)/$(MLTON).trace"
	$(CHMOD) u+x "$(BIN)/$(MLTON).trace"

######################################################################

# smlnj targets

.PHONY: bootstrap-smlnj
bootstrap-smlnj:
	$(MAKE) smlnj-mlton
	$(RM) "$(BIN)/$(MLTON)"
	$(MAKE) BOOTSTRAP_MLTON=$(MLTON).smlnj all
	smlnj_heap_suffix=`echo 'TextIO.output (TextIO.stdErr, SMLofNJ.SysInfo.getHeapSuffix ());' | sml 2>&1 1> /dev/null` && $(RM) "$(LIB)/$(MLTON_OUTPUT)-smlnj.$$smlnj_heap_suffix"
	$(RM) "$(BIN)/$(MLTON).smlnj"

.PHONY: smlnj-mlton
smlnj-mlton:
	$(MAKE) dirs
	$(MAKE) runtime
	$(MAKE) -C "$(SRC)/mlton" smlnj-mlton
	smlnj_heap_suffix=`echo 'TextIO.output (TextIO.stdErr, SMLofNJ.SysInfo.getHeapSuffix ());' | sml 2>&1 1> /dev/null` && $(CP) "$(SRC)/mlton/$(MLTON_OUTPUT)-smlnj.$$smlnj_heap_suffix" "$(LIB)/"
	$(MAKE) script
	$(MAKE) basis-no-check
	$(MAKE) libraries-no-check
	$(SED) \
		-e 's;doitMLton "$$@";# doitMLton "$$@";' \
		-e 's;doitPolyML "$$@";# doitPolyML "$$@";' \
		< "$(BIN)/$(MLTON)" \
		> "$(BIN)/$(MLTON).smlnj"
	$(CHMOD) u+x "$(BIN)/$(MLTON).smlnj"
	@echo 'Build of MLton (with SML/NJ) succeeded.'

.PHONY: smlnj-mlton-x2
smlnj-mlton-x2:
	$(MAKE) SMLNJ_CM_SERVERS_NUM=2 smlnj-mlton

.PHONY: smlnj-mlton-x4
smlnj-mlton-x4:
	$(MAKE) SMLNJ_CM_SERVERS_NUM=4 smlnj-mlton

.PHONY: smlnj-mlton-x8
smlnj-mlton-x8:
	$(MAKE) SMLNJ_CM_SERVERS_NUM=8 smlnj-mlton

.PHONY: smlnj-mlton-x16
smlnj-mlton-x16:
	$(MAKE) SMLNJ_CM_SERVERS_NUM=16 smlnj-mlton

######################################################################

# polyml targets

.PHONY: bootstrap-polyml
bootstrap-polyml:
	$(MAKE) polyml-mlton
	$(RM) "$(BIN)/$(MLTON)"
	$(MAKE) BOOTSTRAP_MLTON=$(MLTON).polyml all
	$(RM) "$(LIB)/$(MLTON)-polyml$(EXE)"
	$(RM) "$(BIN)/$(MLTON).polyml"

.PHONY: polyml-mlton
polyml-mlton:
	$(MAKE) dirs
	$(MAKE) runtime
	$(MAKE) -C "$(SRC)/mlton" polyml-mlton
	$(CP) "$(SRC)/mlton/mlton-polyml$(EXE)" "$(LIB)/"
	$(MAKE) script
	$(MAKE) basis-no-check
	$(MAKE) libraries-no-check
	$(SED) \
		-e 's;doitMLton "$$@";# doitMLton "$$@";' \
		-e 's;doitSMLNJ "$$@";# doitSMLNJ "$$@";' \
		< "$(BIN)/$(MLTON)" \
		> "$(BIN)/$(MLTON).polyml"
	$(CHMOD) u+x "$(BIN)/$(MLTON).polyml"
	@echo 'Build of MLton (with Poly/ML) succeeded.'

######################################################################

# version target

.PHONY: version
version:
	@echo 'Instantiating version numbers.'
	$(SED) \
		-e "s/^MLTON_VERSION := .*/MLTON_VERSION := $(MLTON_VERSION)/" \
		-e "s/^RELEASE := .*/RELEASE := true/" \
		< "$(SRC)/Makefile.config" \
		> z && \
		$(MV) z "$(SRC)/Makefile.config";

######################################################################

# install and release targets

prefix := $(PREFIX)
exec_prefix := $(prefix)
bindir := $(exec_prefix)/bin
datarootdir := $(prefix)/share
docdir := $(datarootdir)/doc/mlton
libdir := $(exec_prefix)/lib
mandir := $(datarootdir)/man
man1dir := $(mandir)/man1

TBIN := $(DESTDIR)$(bindir)
TLIB := $(DESTDIR)$(libdir)/mlton
TMAN := $(DESTDIR)$(man1dir)
TDOC := $(DESTDIR)$(docdir)
TEXM := $(TDOC)/examples

TLIB_REL_TBIN := $(shell $(call TGT_REL_SRC,$(TLIB),$(TBIN)))

GZIP_MAN := true
ifeq ($(findstring $(TARGET_OS), openbsd solaris), $(TARGET_OS))
GZIP_MAN := false
endif

.PHONY: install
install: install-no-strip install-strip

MAN_PAGES := mlton.1
MAN_PAGES := $(MAN_PAGES) \
	mllex.1 \
	mlnlffigen.1 \
	mlprof.1 \
	mlyacc.1

.PHONY: install-no-strip
install-no-strip:
	$(MKDIR) "$(TBIN)" "$(TLIB)"
	$(CP) "$(BIN)/." "$(TBIN)/"
	$(SED) \
		-e "s;^LIB_REL_BIN=.*;LIB_REL_BIN=\"$(TLIB_REL_TBIN)\";" \
		< "$(BIN)/$(MLTON)" > "$(TBIN)/$(MLTON)"
	$(CHMOD) a+x "$(TBIN)/$(MLTON)"
	$(CP) "$(LIB)/." "$(TLIB)/"
	$(MKDIR) "$(TMAN)"
	cd "$(SRC)/man" && $(CP) $(MAN_PAGES) "$(TMAN)/"
ifeq (true, $(GZIP_MAN))
	cd "$(TMAN)" && $(GZIP) --force --best $(MAN_PAGES);
endif

STRIP_PROGS := "$(TLIB)/$(MLTON_OUTPUT)$(EXE)"
STRIP_PROGS := $(STRIP_PROGS) \
	"$(TBIN)/mllex$(EXE)" \
	"$(TBIN)/mlnlffigen$(EXE)" \
	"$(TBIN)/mlprof$(EXE)" \
	"$(TBIN)/mlyacc$(EXE)"

.PHONY: install-strip
install-strip: install-no-strip

=== basis-library/Makefile ===
## Copyright (C) 2010,2013,2016-2017,2019 Matthew Fluet.
 # Copyright (C) 1999-2006, 2008 Henry Cejtin, Matthew Fluet, Suresh
 #    Jagannathan, and Stephen Weeks.
 # Copyright (C) 1997-2000 NEC Research Institute.
 #
 # MLton is released under a HPND-style license.
 # See the file MLton-LICENSE for details.
 ##

ROOT := ..
include $(ROOT)/Makefile.config

######################################################################

all:

.PHONY: clean
clean:
	$(SRC)/bin/clean


RESOLVE_SCOPES = program topdec strdec dec
OBJPTR_MAPS = objptr-rep32.map objptr-rep64.map
NORMAL_METADATA_MAPS = normal-metadata-size32.map normal-metadata-size64.map normal-metadata-size128.map
SEQUENCE_METADATA_MAPS = sequence-metadata-size96.map sequence-metadata-size128.map sequence-metadata-size196.map sequence-metadata-size256.map
SEQINDEX_MAPS = seqindex-int32.map seqindex-int64.map 
DEFAULT_CHAR = char8
DEFAULT_INT = int32 int64 intinf
DEFAULT_REAL = real32 real64
DEFAULT_WORD = word32 word64

.PHONY: def-use
def-use:
	"$(BIN)/$(MLTON)" -disable-ann deadCode -stop tc -show-types true \
		-prefer-abs-paths true -show-def-use basis-library.def-use \
		libs/all.mlb

.PHONY: type-check-def
type-check-def:
	"$(BIN)/$(MLTON)" -disable-ann deadCode -stop tc -show-types true \
		libs/all.mlb

.PHONY: type-check-all
type-check-all:
	for resolvescope in $(RESOLVE_SCOPES); do \
	for objptr in $(OBJPTR_MAPS); do \
	for normalmetadata in $(NORMAL_METADATA_MAPS); do \
	for sequencemetadata in $(SEQUENCE_METADATA_MAPS); do \
	for seqindex in $(SEQINDEX_MAPS); do \
	for defchar in $(DEFAULT_CHAR); do \
	for defint in $(DEFAULT_INT); do \
	for defreal in $(DEFAULT_REAL); do \
	for defword in $(DEFAULT_WORD); do \
	echo "Type checking: $$resolvescope  $$objptr $$normalmetadata $$sequencemetadata $$seqindex  $$defchar $$defint $$defreal $$defword"; \
	echo "$(MLTON)" -disable-ann deadCode -disable-ann resolveScope -default-ann "\"resolveScope $$resolvescope\"" -stop tc -show-types true \
		-mlb-path-map "maps/$$objptr" \
		-mlb-path-map "maps/$$normalmetadata" \
		-mlb-path-map "maps/$$sequencemetadata" \
		-mlb-path-map "maps/$$seqindex" \
		-default-type "$$defchar" \
		-default-type "$$defint" \
		-default-type "$$defreal" \
		-default-type "$$defword" \
		libs/all.mlb; \
	"$(MLTON)" -disable-ann deadCode -disable-ann resolveScope -default-ann "resolveScope $$resolvescope" -stop tc -show-types true \
		-mlb-path-map "maps/$$objptr" \
		-mlb-path-map "maps/$$normalmetadata" \
		-mlb-path-map "maps/$$sequencemetadata" \
		-mlb-path-map "maps/$$seqindex" \
		-default-type "$$defchar" \
		-default-type "$$defint" \
		-default-type "$$defreal" \
		-default-type "$$defword" \
		libs/all.mlb; \
	done; done; done; done; done; done; done; done; done;

=== benchmark/Makefile ===
## Copyright (C) 2013,2019 Matthew Fluet.
 # Copyright (C) 2009 Matthew Fluet.
 # Copyright (C) 1999-2007 Henry Cejtin, Matthew Fluet, Suresh
 #    Jagannathan, and Stephen Weeks.
 # Copyright (C) 1997-2000 NEC Research Institute.
 #
 # MLton is released under a HPND-style license.
 # See the file MLton-LICENSE for details.
 ##

ROOT := ..
include $(ROOT)/Makefile.config

######################################################################

NAME := benchmark

all: 	$(NAME)

RUN_MLTON_COMPILE_XARGS := -default-ann 'sequenceNonUnit warn' -default-ann 'warnUnused true'

$(NAME): $(NAME).mlb $(shell "$(RUN_MLTON)" -stop f $(NAME).mlb)
	@echo 'Compiling $(NAME)'
	"$(RUN_MLTON)" @MLton $(RUN_MLTON_RUNTIME_ARGS) -- $(RUN_MLTON_COMPILE_ARGS) $(RUN_MLTON_COMPILE_XARGS) -target $(TARGET) $(NAME).mlb

.PHONY: clean
clean:
	../bin/clean

BENCH := barnes-hut boyer checksum count-graphs DLXSimulator even-odd fft fib flat-array hamlet imp-for knuth-bendix lexgen life logic mandelbrot matrix-multiply md5 merge mlyacc model-elimination mpuz nucleic output1 peek psdes-random ratio-regions ray raytrace simple smith-normal-form string-concat tailfib tak tensor tsp tyan vector32-concat vector64-concat vector-rev vliw wc-input1 wc-scanStream zebra zern
FPBENCH := barnes-hut fft hamlet mandelbrot matrix-multiply nucleic ray raytrace simple tensor tsp tyan vliw zern

BFLAGS := -mlton "/usr/bin/mlton" -mlton "mlton -optimize-ssa {false,true}"
BFLAGS := -wiki -mlton "/usr/bin/mlton" -mlkit -mosml -poly -smlnj
BFLAGS := -mlton "$(BIN)/mlton"

.PHONY: test
test: $(NAME)
	cd tests && ../benchmark $(BFLAGS) $(BENCH)

QBENCH := $(BENCH)
QBFLAGS := -mlton "~/devel/mlton/builds/20171013.233239-g5513092e3/bin/mlton"
QBFLAGS += -mlton "~/devel/mlton/mlton.git/build/bin/mlton -cse-canon {ascHash,descHash,ascIndex,descIndex}"

.PHONY: qtest
qtest: $(NAME)
	cd tests && ../benchmark $(QBFLAGS) $(QBENCH) && $(MAKE) clean

=== bin/Makefile ===
## Copyright (C) 1999-2005 Henry Cejtin, Matthew Fluet, Suresh
 #    Jagannathan, and Stephen Weeks.
 # Copyright (C) 1997-2000 NEC Research Institute.
 #
 # MLton is released under a HPND-style license.
 # See the file MLton-LICENSE for details.
 ##

all:

.PHONY: clean
clean:
	../bin/clean

=== include/Makefile ===
## Copyright (C) 1999-2005 Henry Cejtin, Matthew Fluet, Suresh
 #    Jagannathan, and Stephen Weeks.
 # Copyright (C) 1997-2000 NEC Research Institute.
 #
 # MLton is released under a HPND-style license.
 # See the file MLton-LICENSE for details.
 ##

all:

.PHONY: clean
clean:
	../bin/clean

=== man/Makefile ===
## Copyright (C) 1999-2005 Henry Cejtin, Matthew Fluet, Suresh
 #    Jagannathan, and Stephen Weeks.
 # Copyright (C) 1997-2000 NEC Research Institute.
 #
 # MLton is released under a HPND-style license.
 # See the file MLton-LICENSE for details.
 ##

all:

.PHONY: ps
ps: mllex.ps mlprof.ps mlton.ps

%.pdf: %.ps
	ps2pdf $<

%.ps: %.1
	man -t ./$< >$@

.PHONY: clean
clean:
	../bin/clean

=== mllex/Makefile ===
## Copyright (C) 2009,2013,2018-2020 Matthew Fluet.
 # Copyright (C) 1999-2006 Henry Cejtin, Matthew Fluet, Suresh
 #    Jagannathan, and Stephen Weeks.
 # Copyright (C) 1997-2000 NEC Research Institute.
 #
 # MLton is released under a HPND-style license.
 # See the file MLton-LICENSE for details.
 ##

ROOT := ..
include $(ROOT)/Makefile.config

######################################################################

NAME := mllex

all:	$(NAME)

$(NAME): $(NAME).mlb $(shell "$(RUN_MLTON_DEPS)" -stop f $(NAME).mlb)
	@echo 'Compiling $(NAME)'
	"$(RUN_MLTON)" @MLton $(RUN_MLTON_RUNTIME_ARGS) -- $(RUN_MLTON_COMPILE_ARGS) -target $(TARGET) $(NAME).mlb

.PHONY: clean
clean:
	$(SRC)/bin/clean


PDFLATEX := pdflatex

doc/mllex.pdf:
	$(MAKE) -C doc mllex.pdf

mllex.pdf: doc/mllex.pdf
	$(CP) doc/mllex.pdf mllex.pdf

DOCS :=
ifneq ($(shell which $(PDFLATEX) 2> /dev/null),)
DOCS += mllex.pdf
endif

.PHONY: docs
docs: $(DOCS)


.PHONY: test
test: $(NAME)
	$(CP) ../mlton/front-end/ml.lex .			\
	$(NAME) ml.lex &&					\
	$(DIFF) ml.lex.sml ../mlton/front-end/ml.lex.sml	\
	$(RM) ml.lex ml.lex.sml

=== mlnlffigen/Makefile ===
## Copyright (C) 2018-2020 Matthew Fluet
 # Copyright (C) 2005-2009 Henry Cejtin, Matthew Fluet, Suresh
 #    Jagannathan, and Stephen Weeks.
 #
 # MLton is released under a HPND-style license.
 # See the file MLton-LICENSE for details.
 ##

ROOT := ..
include $(ROOT)/Makefile.config

######################################################################

NAME := mlnlffigen

all:	$(NAME)

$(NAME): $(NAME).mlb $(shell "$(RUN_MLTON_DEPS)" -stop f $(NAME).mlb)
	@echo 'Compiling $(NAME)'
	"$(RUN_MLTON)" @MLton $(RUN_MLTON_RUNTIME_ARGS) -- $(RUN_MLTON_COMPILE_ARGS) -target $(TARGET) $(NAME).mlb

.PHONY: clean
clean:
	$(SRC)/bin/clean


cppcmd.sml : gen-cppcmd
	./gen-cppcmd > $@

=== mlprof/Makefile ===
## Copyright (C) 2009,2018-2020 Matthew Fluet.
 # Copyright (C) 1999-2006 Henry Cejtin, Matthew Fluet, Suresh
 #    Jagannathan, and Stephen Weeks.
 # Copyright (C) 1997-2000 NEC Research Institute.
 #
 # MLton is released under a HPND-style license.
 # See the file MLton-LICENSE for details.
 ##

ROOT := ..
include $(ROOT)/Makefile.config

######################################################################

NAME := mlprof

all:	$(NAME)

$(NAME): $(NAME).mlb $(shell "$(RUN_MLTON_DEPS)" -stop f $(NAME).mlb)
	@echo 'Compiling $(NAME)'
	"$(RUN_MLTON)" @MLton $(RUN_MLTON_RUNTIME_ARGS) -- $(RUN_MLTON_COMPILE_ARGS) -target $(TARGET) $(NAME).mlb

.PHONY: clean
clean:
	$(SRC)/bin/clean

=== mlton/Makefile ===
## Copyright (C) 2010,2013,2016,2018-2020 Matthew Fluet.
 # Copyright (C) 1999-2009 Henry Cejtin, Matthew Fluet, Suresh
 #    Jagannathan, and Stephen Weeks.
 # Copyright (C) 1997-2000 NEC Research Institute.
 #
 # MLton is released under a HPND-style license.
 # See the file MLton-LICENSE for details.
 ##

ROOT := ..
include $(ROOT)/Makefile.config

######################################################################

RUN_MLTON_RUNTIME_XARGS := ram-slop 0.7
RUN_MLTON_COMPILE_XARGS :=

ifeq (true, $(SELF_COMPILE))
# Older versions of `mlton` may not support `sequenceNonUnit` or `warnUnused`.
RUN_MLTON_COMPILE_XARGS += -default-ann 'sequenceNonUnit warn'
RUN_MLTON_COMPILE_XARGS += -default-ann 'warnUnused true'
# RUN_MLTON_COMPILE_XARGS += -type-check true
# We're self-compiling, so don't use any stubs.
MLTON_MLB := mlton.mlb
else
ifneq (, $(findstring $(HOST_OS),cygwin mingw))
# We're bootstrapping on Cygwin or MinGW; stubs define `spawn` in terms of
# `fork` and `fork` doesn't work on Cygwin or MinGW, so don't use any stubs.
MLTON_MLB := mlton.mlb
else
# We're bootstrapping, so use stubs.
MLTON_MLB := mlton-stubs.mlb
endif
endif

## When self-compiling the current MLton sources with `Zone` enabled,
## the resulting compiler exhibits a space leak; see MLton/mlton#334
ifeq ($(RUN_MLTON_VERSION), $(firstword $(sort $(RUN_MLTON_VERSION) 20170629)))
RUN_MLTON_COMPILE_XARGS += -drop-pass zone
else ifeq ($(RUN_MLTON_VERSION), $(firstword $(sort $(RUN_MLTON_VERSION) 20191003)))
RUN_MLTON_COMPILE_XARGS += -disable-pass zone
endif

FRONT_END_SOURCES :=		\
	front-end/ml.lex.sml	\
	front-end/ml.grm.sig	\
	front-end/ml.grm.sml	\
	front-end/mlb.lex.sml	\
	front-end/mlb.grm.sig	\
	front-end/mlb.grm.sml

SOURCES :=			\
	$(MLTON_MLB)		\
	$(FRONT_END_SOURCES)	\
	control/version.sml	\
	$(shell if [ -e $(MLTON_MLB) ]; then "$(RUN_MLTON_DEPS)" -stop f $(MLTON_MLB); fi)

.PHONY: all
all: $(MLTON_OUTPUT)

.PHONY: clean
clean:
	$(SRC)/bin/clean

SHOW_VARS += MLTON_MLB
$(eval $(MK_SHOW_CONFIG))

######################################################################

$(MLTON_OUTPUT): $(SOURCES)
	@echo 'Compiling mlton'
	"$(RUN_MLTON)" \
		@MLton $(RUN_MLTON_RUNTIME_XARGS) $(RUN_MLTON_RUNTIME_ARGS) gc-summary -- \
		$(RUN_MLTON_COMPILE_XARGS) -verbose 2 $(RUN_MLTON_COMPILE_ARGS)	\
		-target $(TARGET) -output $(MLTON_OUTPUT)			\
		$(MLTON_MLB)

ifeq ($(shell (cat control/version_sml.src; echo '$(MLTON_NAME)' '$(MLTON_VERSION)'; if [ -e control/version.sml ]; then cat control/version.sml; fi) | $(SHA1DGST)),$(shell if [ -e control/version_sml.chk ]; then cat control/version_sml.chk; fi))
control/version.sml: control/version_sml.src
	touch control/version.sml
else
$(shell $(RM) control/version.sml)
control/version.sml: control/version_sml.src
	$(SED) \
		-e "s/MLTON_NAME/$(MLTON_NAME)/" \
		-e "s/MLTON_VERSION/$(MLTON_VERSION)/" \
		< control/version_sml.src \
		> control/version.sml
	(cat control/version_sml.src; echo '$(MLTON_NAME)' '$(MLTON_VERSION)'; cat control/version.sml) | $(SHA1DGST) > control/version_sml.chk
endif

front-end/%.lex.sml: front-end/%.lex
	$(RM) $<.*
	$(RUN_MLLEX) $<
	$(MV) $<.sml $<.sml.in
	$(SED) -e 's/val s = List.map f (List.rev (tl (List.rev s)))/val s = Pervasive.List.map f (Pervasive.List.rev (tl (Pervasive.List.rev s)))/' $<.sml.in > $<.sml
	$(MV) $<.sml $<.sml.in
	$(SED) -e 's/in Vector.fromList(List.map g/in Vector.fromList(Pervasive.List.map g/' $<.sml.in > $<.sml
	$(RM) $<.sml.in
	$(CHMOD) -w $<.*

front-end/%.grm.sig front-end/%.grm.sml: front-end/%.grm
	$(RM) $<.*
	$(RUN_MLYACC) $<
	$(MV) $<.sml $<.sml.in
	$(SED) -e 's/in f 0 handle General.Subscript => ()/in f 0 handle Pervasive.General.Subscript => ()/' $<.sml.in > $<.sml
	$(MV) $<.sml $<.sml.in
	$(SED) -e 's/in Array.fromList(List.map actionRowLookUp actionRowNumbers)/in Array.fromList(Pervasive.List.map actionRowLookUp actionRowNumbers)/' $<.sml.in > $<.sml
	$(RM) $<.sml.in
	$(CHMOD) -w $<.*

mlton-stubs.mlb: $(shell "$(RUN_MLTON_DEPS)" -stop f ../lib/stubs/mlton-stubs/sources.mlb | $(GREP) 'mlb$$') $(shell "$(RUN_MLTON_DEPS)" -stop f mlton.mlb | $(GREP) 'mlb$$')
	(									\
		echo '$$(SML_LIB)/basis/unsafe.mlb';				\
		echo '$$(SML_LIB)/basis/sml-nj.mlb';				\
		echo '$$(SML_LIB)/basis/mlton.mlb';				\
		echo '$$(SML_LIB)/basis/basis.mlb';				\
		$(RUN_MLTON) -stop f mlton.mlb |				\
			$(GREP) -v 'mlb$$' |					\
			$(GREP) 'mlyacc';					\
		$(RUN_MLTON) -stop f ../lib/stubs/mlton-stubs/sources.mlb |	\
			$(GREP) -v 'mlb$$' |					\
			$(GREP) 'mlton-stubs';					\
		$(RUN_MLTON) -stop f mlton.mlb |				\
			$(GREP) -v 'mlb$$' |					\
			$(GREP) -v 'sml/basis' |				\
			$(GREP) -v 'targets' |					\
			$(GREP) -v 'mlyacc';					\
	) > mlton-stubs.mlb

######################################################################

.PHONY: def-use
def-use: mlton.def-use

mlton.def-use: $(SOURCES)
	"$(RUN_MLTON)" \
		@MLton $(RUN_MLTON_RUNTIME_XARGS) $(RUN_MLTON_RUNTIME_ARGS) --	\
		$(RUN_MLTON_COMPILE_XARGS) -verbose 0 $(RUN_MLTON_COMPILE_ARGS)	\
		-stop tc -prefer-abs-paths true -show-def-use mlton.def-use	\
		$(MLTON_MLB)

######################################################################

ifneq (,$(REMOTE_TARGET))
mlton-bootstrap-$(REMOTE_TARGET).tgz: $(SOURCES)
	"$(RUN_MLTON)" \
		@MLton $(RUN_MLTON_RUNTIME_XARGS) $(RUN_MLTON_RUNTIME_ARGS) gc-summary -- \
		$(RUN_MLTON_COMPILE_XARGS) -verbose 2 $(RUN_MLTON_COMPILE_ARGS)	\
		-target $(REMOTE_TARGET) -output $(MLTON_OUTPUT) \
		-codegen c -stop g \
		$(MLTON_MLB)
	$(TAR) czf $@ $(MLTON_OUTPUT).*.c
	$(RM) $(MLTON_OUTPUT).*.c
endif

######################################################################

#
# The following rebuilds the heap file for the SML/NJ compiled version of MLton.
#
SMLNJ := sml
SMLNJ_CM_SERVERS_NUM := 0

.PHONY: smlnj-mlton
smlnj-mlton: mlton-smlnj.cm control/version.sml $(FRONT_END_SOURCES)
	(									\
		echo 'SMLofNJ.Internals.GC.messages false;';			\
		echo '#set CM.Control.verbose false;';				\
		echo '#set CM.Control.warn_obsolete true;';			\
		echo 'Control.polyEqWarn := false;';				\
		echo 'local';							\
		echo 'fun loop 0 = () | loop n = (CM.Server.start {cmd = (CommandLine.name (), ["@CMslave"]), name = "server" ^ (Int.toString n), pathtrans = NONE, pref = 0}; loop (n - 1));'; \
		echo 'in';							\
		echo 'val _ = loop $(SMLNJ_CM_SERVERS_NUM);';			\
		echo 'end;';							\
		echo 'if (CM.make "mlton-smlnj.cm") handle _ => false';		\
		echo '   then ()';						\
		echo '   else OS.Process.exit OS.Process.failure;'; 		\
		echo 'SMLofNJ.exportFn("$(MLTON_OUTPUT)-smlnj",Main.main);'	\
	) | "$(SMLNJ)"

######################################################################

#
# The following rebuilds the executable file for the Poly/ML compiled version of
# MLton.
#
POLYML := poly

.PHONY: polyml-mlton
polyml-mlton: mlton-polyml.use $(shell [ -e mlton-polyml.use ] && cat mlton-polyml.use | $(SED) 's/use "\(.*\)";/\1/') control/version.sml $(FRONT_END_SOURCES)
	(									\
		echo 'use "mlton-polyml.use";';					\
		echo 'PolyML.export("$(MLTON_OUTPUT)-polyml", Main.mainWrapped);'; \
	) | "$(POLYML)"
	$(CC) -o $(MLTON_OUTPUT)-polyml $(MLTON_OUTPUT)-polyml.o -lpolymain -lpolyml
	$(RM) $(MLTON_OUTPUT)-polyml.o

mlton-polyml.use: ../lib/stubs/basis-stubs-for-polyml/sources.use ../lib/stubs/mlton-stubs-for-polyml/sources.use $(shell "$(RUN_MLTON_DEPS)" -stop f ../lib/stubs/mlton-stubs/sources.mlb | $(GREP) 'mlb$$') $(shell "$(RUN_MLTON_DEPS)" -stop f mlton.mlb | $(GREP) 'mlb$$')
	(									\
		cat ../lib/stubs/basis-stubs-for-polyml/sources.use |		\
			$(SED) 's|use "\(.*\)";|../lib/stubs/basis-stubs-for-polyml/\1|'; \
		"$(RUN_MLTON)" -stop f mlton.mlb | $(GREP) -v 'mlb$$' | $(GREP) 'mlyacc'; \
		cat ../lib/stubs/mlton-stubs-for-polyml/sources.use |		\
			$(SED) 's|use "\(.*\)";|../lib/stubs/mlton-stubs-for-polyml/\1|'; \
		"$(RUN_MLTON)" -stop f ../lib/stubs/mlton-stubs/sources.mlb |	\
			$(GREP) -v 'mlb$$' |					\
			$(GREP) 'mlton-stubs';					\
		"$(RUN_MLTON)" -stop f mlton.mlb |				\
			$(GREP) -v 'mlb$$' |					\
			$(GREP) -v 'sml/basis' |				\
			$(GREP) -v 'targets' |					\
			$(GREP) -v 'mlton-stubs' |				\
			$(GREP) -v 'mlyacc' |					\
			$(GREP) -v 'call-main.sml';				\
	) | $(SED) 's|\(.*\)|use "\1";|' > mlton-polyml.use

=== mlyacc/Makefile ===
## Copyright (C) 2009,2013,2018-2020 Matthew Fluet.
 # Copyright (C) 1999-2006 Henry Cejtin, Matthew Fluet, Suresh
 #    Jagannathan, and Stephen Weeks.
 # Copyright (C) 1997-2000 NEC Research Institute.
 #
 # MLton is released under a HPND-style license.
 # See the file MLton-LICENSE for details.
 ##

ROOT := ..
include $(ROOT)/Makefile.config

######################################################################

NAME := mlyacc

all:	$(NAME)

$(NAME): $(NAME).mlb $(shell "$(RUN_MLTON_DEPS)" -stop f $(NAME).mlb)
	@echo 'Compiling $(NAME)'
	"$(RUN_MLTON)" @MLton $(RUN_MLTON_RUNTIME_ARGS) -- $(RUN_MLTON_COMPILE_ARGS) -target $(TARGET) $(NAME).mlb

.PHONY: clean
clean:
	$(SRC)/bin/clean

src/%.lex.sml: src/%.lex
	$(RM) $<.*
	$(RUN_MLLEX) $<
	$(CHMOD) -w $<.*

src/%.grm.sig src/%.grm.sml: src/%.grm
	$(RM) $<.*
	$(RUN_MLYACC) $<
	$(CHMOD) -w $<.*


PDFLATEX := pdflatex

doc/mlyacc.pdf:
	$(MAKE) -C doc mlyacc.pdf

mlyacc.pdf: doc/mlyacc.pdf
	$(CP) doc/mlyacc.pdf .

DOCS :=
ifneq ($(shell which $(PDFLATEX) 2> /dev/null),)
DOCS += mlyacc.pdf
endif

.PHONY: docs
docs: $(DOCS)


.PHONY: test
test: $(NAME)
	$(CP) ../mlton/front-end/ml.grm .			\
	$(NAME) ml.grm &&					\
	$(DIFF) ml.grm.sig ../mlton/front-end/ml.grm.sig &&	\
	$(DIFF) ml.grm.sml ../mlton/front-end/ml.grm.sml	\
	$(RM) ml.grm ml.grm.sig ml.grm.sml ml.grm.desc

=== regression/Makefile ===
## Copyright (C) 1999-2006 Henry Cejtin, Matthew Fluet, Suresh
 #    Jagannathan, and Stephen Weeks.
 # Copyright (C) 1997-2000 NEC Research Institute.
 #
 # MLton is released under a HPND-style license.
 # See the file MLton-LICENSE for details.
 ##

all: 

.PHONY: clean
clean:
	../bin/clean
	rm -f *.[csS]
	for f in *; do 			\
		if [ -x "$$f" -a ! -d "$$f" ]; then	\
			rm -f "$$f";		\
		fi;				\
	done


.PHONY: abnormal
abnormal:
	ls -1 | egrep -v '\.ok$$|\.sml$$'

=== debian/changelog ===
mlton (20210117+dfsg-3) unstable; urgency=medium

  * Replace build-depends-arch on mlton with mlton-compiler and mlton-tools to
    avoid pulling in mlton-doc
  * Drop version in mlton's recommends of mlton-doc
  * Make mlton-basis Arch: any instead of Arch: all. This avoids race
    conditions on buildds, where mlton-compiler sometimes became uninstallable
    if the new mlton-basis package got built before mlton-compiler on a given
    architecture, thereby making the previous version of mlton-compiler
    uninstallable. This then required manually rebootstrapping the
    architecture.
    + The build-indep target in debian/rules now only builds documentation
    + Drop 09_install-indep.diff, no longer needed
    + Transition versioned dependencies on mlton-basis from
      (= ${source:Version}) to (= ${binary:Version})

 -- Ryan Kavanagh <rak@debian.org>  Tue, 04 Jan 2022 18:38:53 -0500

mlton (20210117+dfsg-2) unstable; urgency=medium

  * Move libgmp-dev to build-depends to fix binary-all builds
  * Drop dblatex build-dependency while we are not building the guide

 -- Ryan Kavanagh <rak@debian.org>  Tue, 04 Jan 2022 13:37:28 -0500

mlton (20210117+dfsg-1) unstable; urgency=medium

  * New upstream release (Closes: #992099)
  * Repack sources to remove non-DFSG files (Closes: #998156)
    + Extract and apply upstream patches to all nested tarballs while we are
      at it
    + Patch sources to handle missing non-DFSG-free files, 07_DFSG.diff
    + Disable installing mlnlffigen: it requires non-DFSG-free ckit-lib to build
  * Changes to patches:
    + Drop ppc64el.patch: applied upstream
    + Drop linux-pic.diff: no longer needed to successfully compile on amd64
    * Drop stack-hardening.diff: pass in flags via debian/rules instead
    + Rename patches to make application order obvious
    + Add DEP3 headers to all patches
  * Overhaul control file:
    + Move Homepage field from binary stanzas to source stanza
    + Use substvars to eliminate description duplication
    + Split Build-Depends into Build-Depends-Arch/Build-Depends-Indep
    + Drop alternative dependency on mlton-runtime, which has not existed
      since forever
    + Drop build-dependency on quilt and on procps
    + Drop breaks against mlton version now in oldoldoldstable
    + Added Vcs-* tags
    + Drop versioned Build-Depends-Arch on binutils and gcc for mips/mipsel:
      no longer needed
    + Set Rules-Requires-Root: no
    + Bump standards version to 4.6.0
  * Changes to documentation:
    + Updated README.Debian to reflect current mlton requirements
    + Added a README.source to describe repacking and bootstrapping process
  * Set myself as maintainer (Closes: #995467)
  * Documentation-related changes:
    + The mlton guide does not currently build. Temporarily disable building
      it for the sake of getting a working mlton compiler back in the archive
    + Temporarily disable installation of mllex and mlyacc guides
    + Documentation requires a build-dependency on python3-pygments instead of
      python-pygments (Closes: #943118)
    + Reintroduce build-dependency on dblatex
    + Install upstream changelog and readme.
  * Changes to package build process:
    + Switch from CDBS to debhelper
    + Set compat to 13 via debhelper-compat
    + Don't fetch resources from Github during build, 06_local_docs.diff
    + Remember to clean generated files under .cm/
    + Don't automatically run tests during build, 08_postpone_tests.diff
    + Add target to install arch-indep libraries, 09_install-indep.diff, and
      call it from rules
    + dh_missing should ignore
      - files for arch-dependent packages when building
        arch-independent packages
      - upstream license files usr/share/doc/mlton/license/*
  * Update copyright file and switch to DEP5 format

 -- Ryan Kavanagh <rak@debian.org>  Tue, 04 Jan 2022 09:12:48 -0500

=== debian/control ===
Source: mlton
Section: devel
Priority: optional
Maintainer: Ryan Kavanagh <rak@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 libgmp-dev,
Build-Depends-Arch:
 dh-exec,
 mlton-compiler,
 mlton-tools,
Build-Depends-Indep:
 asciidoc,
 graphicsmagick,
 python3-pygments,
Homepage: http://mlton.org/
Standards-Version: 4.6.0
Description: Optimizing compiler for Standard ML
 MLton is a whole-program optimizing compiler for Standard ML.
 MLton generates standalone executables with excellent runtime
 performance, is SML 97 compliant, and has a complete basis
 library. MLton has source-level profiling, a fast C FFI, an
 interface to the GNU multiprecision library, and lots of useful
 libraries.
Vcs-Browser: https://salsa.debian.org/debian/mlton
Vcs-Git: https://salsa.debian.org/debian/mlton.git -b debian/unstable
Rules-Requires-Root: no

Package: mlton
Architecture: all
Multi-Arch: foreign
Depends:
 mlton-compiler (<< ${source:Version}.1~),
 mlton-compiler (>= ${source:Version}),
 mlton-tools (<< ${source:Version}.1~),
 mlton-tools (>= ${source:Version}),
 ${misc:Depends},
Recommends:
 mlton-doc
Description: ${source:Synopsis}
 ${source:Extended-Description}
 .
 This metapackage depends on all MLton packages.

Package: mlton-basis
Architecture: any
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: ${source:Synopsis} - basis library
 ${source:Extended-Description}
 .
 This package includes the cross-platform basis.

Package: mlton-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: ${source:Synopsis} - documentation
 ${source:Extended-Description}
 .
 This package includes non-man-page documentation.

Package: mlton-compiler
Architecture: alpha amd64 arm64 armel armhf hppa i386 kfreebsd-amd64 kfreebsd-i386 mips mips64el mipsel powerpc ppc64el riscv64 s390x sparc
Multi-Arch: foreign
Depends:
 gcc,
 libc6-dev,
 libgmp-dev,
 mlton-basis (= ${binary:Version}),
 mlton-runtime-native (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} - compiler
 ${source:Extended-Description}
 .
 This package includes the compiler itself.

Package: mlton-tools
Architecture: alpha amd64 arm64 armel armhf hppa i386 kfreebsd-amd64 kfreebsd-i386 mips mips64el mipsel powerpc ppc64el riscv64 s390x sparc
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} - tools
 ${source:Extended-Description}
 .
 This package includes tools which autogenerate SML.

Package: mlton-runtime-native
Architecture: alpha amd64 arm64 armel armhf hppa i386 kfreebsd-amd64 kfreebsd-i386 mips mips64el mipsel powerpc ppc64el riscv64 s390x sparc
Depends:
 mlton-runtime-alpha-linux-gnu (= ${binary:Version}) [alpha] | mlton-runtime-x86-64-linux-gnu (= ${binary:Version}) [amd64] | mlton-runtime-aarch64-linux-gnu (= ${binary:Version}) [arm64] | mlton-runtime-arm-linux-gnueabi (= ${binary:Version}) [armel] | mlton-runtime-arm-linux-gnueabihf (= ${binary:Version}) [armhf] | mlton-runtime-hppa-linux-gnu (= ${binary:Version}) [hppa] | mlton-runtime-i486-linux-gnu (= ${binary:Version}) [i386] | mlton-runtime-i486-kfreebsd-gnu (= ${binary:Version}) [kfreebsd-i386] | mlton-runtime-x86-64-kfreebsd-gnu (= ${binary:Version}) [kfreebsd-amd64] | mlton-runtime-mips64el-linux-gnuabi64 (= ${binary:Version}) [mips64el] | mlton-runtime-mips-linux-gnu (= ${binary:Version}) [mips] | mlton-runtime-mipsel-linux-gnu (= ${binary:Version}) [mipsel] | mlton-runtime-powerpc-linux-gnu (= ${binary:Version}) [powerpc] | mlton-runtime-powerpc64le-linux-gnu (= ${binary:Version}) [ppc64el] | mlton-runtime-s390x-linux-gnu (= ${binary:Version}) [s390x] | mlton-runtime-sparc-linux-gnu (= ${binary:Version}) [sparc],
 ${misc:Depends},
Description: ${source:Synopsis} - native runtime libraries
 ${source:Extended-Description}
 .
 This metapackage depends on native target libraries.

Package: mlton-runtime-alpha-linux-gnu
Architecture: alpha
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

Package: mlton-runtime-x86-64-linux-gnu
Architecture: amd64
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

Package: mlton-runtime-aarch64-linux-gnu
Architecture: arm64
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

Package: mlton-runtime-arm-linux-gnueabi
Architecture: armel
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

Package: mlton-runtime-arm-linux-gnueabihf
Architecture: armhf
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

Package: mlton-runtime-hppa-linux-gnu
Architecture: hppa
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

Package: mlton-runtime-i486-linux-gnu
Architecture: i386
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

Package: mlton-runtime-i486-kfreebsd-gnu
Architecture: kfreebsd-i386
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

Package: mlton-runtime-x86-64-kfreebsd-gnu
Architecture: kfreebsd-amd64
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

Package: mlton-runtime-mips64el-linux-gnuabi64
Architecture: mips64el
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

Package: mlton-runtime-mips-linux-gnu
Architecture: mips
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

Package: mlton-runtime-mipsel-linux-gnu
Architecture: mipsel
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

Package: mlton-runtime-powerpc-linux-gnu
Architecture: powerpc
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

Package: mlton-runtime-powerpc64le-linux-gnu
Architecture: ppc64el
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

Package: mlton-runtime-riscv64-linux-gnu
Architecture: riscv64
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

Package: mlton-runtime-s390x-linux-gnu
Architecture: s390x
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

Package: mlton-runtime-sparc-linux-gnu
Architecture: sparc
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
DPKG_EXPORT_BUILDTOOLS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/buildtools.mk
include /usr/share/dpkg/pkg-info.mk

COMMON_OPTS=CC=$(CC) \
	    DESTDIR=$(CURDIR)/debian/tmp \
	    MLTON_VERSION=$(DEB_VERSION) \
	    PREFIX=/usr
MLTON_FLAGS=-as-opt '$(ASFLAGS)' -cc-opt '$(CFLAGS)' -link-opt '$(LDFLAGS)'

%:
	dh $@

override_dh_auto_build-arch:
	$(MAKE) MLTON_COMPILE_ARGS="$(MLTON_FLAGS)" $(COMMON_OPTS) all

override_dh_auto_build-indep:
	$(MAKE) $(COMMON_OPTS) docs
	#$(MAKE) -C doc/guide mlton-guide.pdf

override_dh_auto_install-arch:
	$(MAKE) $(COMMON_OPTS) install-no-strip

override_dh_auto_install-indep:
	$(MAKE) $(COMMON_OPTS) install-docs

override_dh_compress:
	dh_compress -Xmlton/guide -X.sml

override_dh_strip:
	dh_strip --no-automatic-dbgsym

override_dh_missing-indep:
	# The files under usr/lib/mlton/targets/self get installed into
	# the mlton-runtime-* packages, which are not arch-indep.
	# Exclude / ignore them when building with only -A.
	dh_missing -Xusr/lib/mlton/targets/self

override_dh_auto_test-arch:
	$(MAKE) $(COMMON_OPTS) check
	$(MAKE) $(COMMON_OPTS) basis-check
	$(MAKE) $(COMMON_OPTS) libraries-check

=== debian/watch ===
# Compulsory line, this is a version 4 file
version=4

# GitHub hosted projects
opts="dversionmangle=s/\+dfsg\d*$//, \
      mode=git, gitmode=full, pgpmode=none" \
   https://github.com/MLton/mlton/ \
   refs/tags/on-@ANY_VERSION@-release
